﻿
local acceptres				= true
local battlegroundres			        = true
local cancelduels					= true
local hideerrors			= true
local reputationwatch			        = true
local dingannounce			                = false
local doubleclickinvite			= true
local acceptfriendlyinvites	                = true
local autorepair				        = true
local autorepairguild			= true
local selljunk				        = true
local easyaddfriend				        = true
local fatiguewarner      		= false
local interruptedmsg			        = true
local leavepartymsg			= true

local slshCmnd_CommandLists		= true
local slshCmnd_LeaveParty		        = true
local slshCmnd_ReloadUI			                = true
local slshCmnd_XP			= false
local slshCmnd_Readycheck		        = true
local slshCmnd_DisbandRaid		                = true
local slshCmnd_ConvertToParty		= true
local slshCmnd_ConvertToRaid		        = true

--[[-----------------------------------------------------------------------------

Setting descriptions:

To disable an option set it to false or true.

Accept Res.
	Automatically accept a resurrect request if not in combat and thank the
	caster.

Battleground Res.
	Automatically release when you die in a battle ground.

Cancel Duels.
	Automatically decline any duel request unless you are holding down the CTRL
	key.

Hide Errors.
	Disable error messages: Not enough energy, Not enough mana, ...

Reputation Watch.
	Automatically change the reputation bar to the reputation you last gained.

Ding Announce.
	Announce when you level up to your guild and/or raid/party (if in one).

Double Click Invite.
	Enable double clicking a friend in the Friends Frame to invite them to a
	group (supports RealID).

Mount Macro.
        #showtooltip
        /use [nomod, button:1] Brown Riding Camel
        /use [nomod, button:2] Ironbound Proto-Drake
        /use [mod:ctrl] Abyssal Seahorse

        if you dont have the seahorse you can add a 3rd 
        mount like a 2-seater.

        you an also add a 4th and 5th by doing.
        i tend to use for my instance mounts.

       /use [mod:alt] Yellow Qiraji Battle Tank
       /use [mod:shift] X-53 Touring Rocket

Accept Friendly Invites.
	Automatically accept party invites from people in your guild or on your
	friends list.

Auto Repair.
	Automatically repair all of your gear when visiting an applicable merchant.

Auto Repair Guild.
	Automatically repair all of your gear when visiting an applicable merchant,
	From guild funds.

Sell Junk.
	Automatically sell all of your grey quality items when visiting a merchant.
	Note: There is a grey item in Swamp of Sorrows that starts 	a quest:
	http://www.wowhead.com/?item=6196

Easy Add Friend.
	Right click and add friend on the menu.

Fatigue Warner.
        gives a sound warning, when you get the exhaustion/fatigue 'debuff' - you will also hear it when you disabled sounds.
"To chane the sound, see code"

Interrupted msg.
        Outputs a message when you successfully interrupt.
        Will Print to Raid or Party.

leavepartymsg.
        Shows a box, asking if you would like to leave group.          

SlshCmnd_LeaveParty.
	Create a slash command /lp that will leave your party.

SlshCmnd_ReloadUI.
	Create a slash command /rl that will reload the user interface.

SlshCmnd_XP.
	Create a slash command /xp that will output your experience status to chat.

SlshCmnd_Readycheck.
	Create a slash command /rc that will output your party with a ready check, Will 
post message if not Leader or Assist.

SlshCmnd_DisbandRaid.
        Create a slash command /dr that will disband your raid, With a message "Disbanding Raid!",
only if you are Raid Leader or Assist.

SlshCmnd_ConvertToParty.
        Create a slash command /c2p that will Converts a raid into a party.

slshCmnd_ConvertToRaid.
        Create a slash command /c2r that will Converts a party into a raid.

-------------------------------------------------------------------------------]]

local addonName, eventHandlers = ..., { }

--[[-----------------------------------------------------------------------------
Accept Res
-------------------------------------------------------------------------------]]
if acceptres then
	eventHandlers['RESURRECT_REQUEST'] = function(name)
		if not (UnitAffectingCombat('player') or UnitAffectingCombat(name)) then
			local delay = GetCorpseRecoveryDelay()
			if delay == 0 then
				AcceptResurrect()
				DoEmote('thank', name)
			else
                                local b = CreateFrame("Button")
				local formattedText = b:GetText(b:SetFormattedText("%d |4second:seconds", delay))
				SendChatMessage("感謝您的救人! 我還有 "..formattedText.." 秒後才能接受復活.", 'WHISPER', nil, name)
			end
		end
	end
end

--[[-----------------------------------------------------------------------------
Battleground Res
-------------------------------------------------------------------------------]]
if battlegroundres then
	eventHandlers['PLAYER_DEAD'] = function()
			if (MiniMapBattlefieldFrame.status=='active') or (GetRealZoneText()=='Wintergrasp') or (GetRealZoneText()=='TolBarad') then
			RepopMe()
		end
	end
end

--[[-----------------------------------------------------------------------------
Cancel Duels
-------------------------------------------------------------------------------]]
if cancelduels then
	eventHandlers['DUEL_REQUESTED'] = function(name)
		if not IsControlKeyDown() then
			CancelDuel()
			DoEmote('no', 1)
			print("來自 " .. name .. " 的決鬥請求已拒絕, 按住CTRL來允許下次的決鬥請求.")
		end
	end
end

--[[-----------------------------------------------------------------------------
Hide Errors
-------------------------------------------------------------------------------]]
if hideerrors then
	local allowedErrors = { }

	eventHandlers['UI_ERROR_MESSAGE'] = function(message)
		if allowedErrors[message] then
			UIErrorsFrame:AddMessage(message, 1, .1, .1)
		end
	end

	UIErrorsFrame:UnregisterEvent('UI_ERROR_MESSAGE')
end

--[[-----------------------------------------------------------------------------
Reputation Watch
-------------------------------------------------------------------------------]]
if reputationwatch then
	local playerGuild = GetGuildInfo('player')

	eventHandlers['CHAT_MSG_COMBAT_FACTION_CHANGE'] = function(message)
		local faction = message:match('Reputation with (.+) increased by ')
		if faction == 'Guild Reputation' then
			faction = playerGuild
		end
		for index = 1, GetNumFactions() do
			if GetFactionInfo(index) == faction then
				SetWatchedFactionIndex(index)
				return
			end
		end
	end

	eventHandlers['PLAYER_GUILD_UPDATE'] = function()
		playerGuild = GetGuildInfo('player')
    end
end

--[[-----------------------------------------------------------------------------
Ding Announce
-------------------------------------------------------------------------------]]
if dingannounce then
	eventHandlers['PLAYER_LEVEL_UP'] = function()
		local message = "DING!"
		if GetNumRaidMembers() > 0 then
			SendChatMessage(message, 'RAID')
		elseif GetNumPartyMembers() > 0 then
			SendChatMessage(message, 'PARTY')
		end
		if IsInGuild() then
			SendChatMessage(message, 'GUILD')
		end
	end
end	

--[[-----------------------------------------------------------------------------
Double Click Invite
-------------------------------------------------------------------------------]]
if doubleclickinvite then
	local function OnDoubleClick(self, button)
		if button == 'LeftButton' then
			if self.buttonType == FRIENDS_BUTTON_TYPE_WOW then
				local name, _, _, _, connected = GetFriendInfo(self.id)
				if connected then
					InviteUnit(name)
				end
			elseif self.buttonType == FRIENDS_BUTTON_TYPE_BNET then
				local _, _, _, toonName, _, client, isOnline = BNGetFriendInfo(self.id)
				if client == 'WoW' and isOnline then
					local _, _, _, realm = BNGetFriendToonInfo(self.id, 1)
					if realm == GetRealmName() then
						InviteUnit(toonName)
					end
				end
			end
		end
	end

	local buttons = FriendsFrameFriendsScrollFrame.buttons
	for index = 1, #buttons do
		buttons[index]:SetScript('OnDoubleClick', OnDoubleClick)
    end
end

--[[-----------------------------------------------------------------------------
Accept Friendly Invites
-------------------------------------------------------------------------------]]
if acceptfriendlyinvites then
	eventHandlers['PARTY_INVITE_REQUEST'] = function(name)
		local accept
		ShowFriends()
		for index = 1, GetNumFriends() do
			if GetFriendInfo(index) == name then
				accept = true
				break
			end
		end
		if not accept and IsInGuild() then
			GuildRoster()
			for index = 1, GetNumGuildMembers() do
				if GetGuildRosterInfo(index) == name then
					accept = true
					break
				end
			end
		end
		if not accept then
			for index = 1, BNGetNumFriends() do
				local _, _, _, toonName = BNGetFriendInfo(index)
				if toonName == name then
					accept = true
					break
				end
			end
		end
		if accept then
			name = StaticPopup_Visible('PARTY_INVITE')
			if name then
				StaticPopup_OnClick(_G[name], 1)
				return
			end
		else
			SendWho('n-"' .. name .. '"')
		end
	end
end

--[[-----------------------------------------------------------------------------
Autorepair or Autorepairguild / SellJunk
-------------------------------------------------------------------------------]]
if autorepair or autorepairguild or selljunk then
	local handler = ""

	if selljunk then
		handler = handler .. [[
			local total = 0
			for bag = 0, NUM_BAG_FRAMES do
				for slot = 1, GetContainerNumSlots(bag) do
					local link = GetContainerItemLink(bag, slot)
					if link then
						local _, _, itemRarity, _, _, _, _, _, _, _, itemSellPrice = GetItemInfo(link)
						local _, itemCount = GetContainerItemInfo(bag, slot)
						if itemRarity == 0 and itemSellPrice ~= 0 then
							total = total + (itemSellPrice * itemCount)
							UseContainerItem(bag, slot)
						end
					end
				end
			end
			if total > 0 then
				print("出售所有灰色物品獲得 " .. MoneyToString(total))
			end
		]]
	end

	if autorepairguild then
		handler = handler .. [[
			if CanGuildBankRepair() then
				local cost, canRepair = GetRepairAllCost()
				if canRepair and cost > 0 then
					RepairAllItems(1)
					local newCost = GetRepairAllCost()
					if newCost < cost then
						print("使用公會資金修理所有裝備花費: " .. MoneyToString(cost - newCost))
					end
				end
			end
		]]
	end

	-- Sell first so there is more money for repairs
	if autorepair then
		handler = handler .. [[
			local cost, canRepair = GetRepairAllCost()
			if canRepair and cost > 0 and cost <= GetMoney() * 0.2 then
				RepairAllItems()
				print("修理花費: " .. MoneyToString(cost))
			end
		]]
	end

	eventHandlers['MERCHANT_SHOW'] = loadstring(([=[
		local cuInd = [[|TInterface\MoneyFrame\UI-CopperIcon:0:1:2:0|t]]
		local agInd = [[|TInterface\MoneyFrame\UI-SilverIcon:0:1:2:0|t ]]
		local auInd = [[|TInterface\MoneyFrame\UI-GoldIcon:0:1:2:0|t ]]

		local function MoneyToString(ammount)
			local cu = ammount %% 100
			ammount = floor(ammount / 100)
			local ag, au = ammount %% 100, floor(ammount / 100)
			if au > 0 then
				return au .. auInd .. ag .. agInd .. cu .. cuInd
			elseif ag > 0 then
				return ag .. agInd .. cu .. cuInd
			end
			return cu .. cuInd
		end

		local function Handler(...)
			%s
		end

		return Handler
	]=]):format(handler))()
end

--[[-----------------------------------------------------------------------------
Easy Add Friend
-------------------------------------------------------------------------------]]
if easyaddfriend then
local EasyAddFriend = CreateFrame("Frame","EasyAddFriendFrame")
EasyAddFriend:SetScript("OnEvent", function() hooksecurefunc("UnitPopup_ShowMenu", EasyAddFriendCheck) EasyAddFriendSlash() end)
EasyAddFriend:RegisterEvent("PLAYER_LOGIN")

local PopupUnits = {"PARTY", "PLAYER", "RAID_PLAYER", "RAID", "FRIEND", "TEAM", "CHAT_ROSTER", "TARGET", "FOCUS"}

local AddFriendButtonInfo = {
	text = "增加好友",
	value = "ADD_FRIEND",
	func = function() AddFriend(UIDROPDOWNMENU_OPEN_MENU.name) end,
	notCheckable = 1,
}

local CancelButtonInfo = {
	text = "取消",
	value = "CANCEL",
	notCheckable = 1
}

function EasyAddFriendSlash()
	SLASH_EASYADDFRIEND1 = "/add";
	SlashCmdList["EASYADDFRIEND"] = function(msg) if #msg == 0 then DEFAULT_CHAT_FRAME:AddMessage("EasyAddFriend: Use '/add' followed by a character's name to add them to your friends list.") else AddFriend(msg) end end
end
function EasyAddFriendCheck()		
	local PossibleButton = getglobal("DropDownList1Button"..(DropDownList1.numButtons)-1)
	if PossibleButton["value"] ~= "ADD_FRIEND" then
		local GoodUnit = false
		for i=1, #PopupUnits do	
		if OPEN_DROPDOWNMENUS[1]["which"] == PopupUnits[i] then	
			GoodUnit = true
			end
		end
		if UIDROPDOWNMENU_OPEN_MENU["unit"] == "target" and ((not UnitIsPlayer("target")) or (not UnitIsFriend("player", "target"))) then
			GoodUnit = false
		end
		if GoodUnit then				
			local IsAlreadyFriend = false
			for z=1, GetNumFriends() do
				if GetFriendInfo(z) == UIDROPDOWNMENU_OPEN_MENU["name"] or UIDROPDOWNMENU_OPEN_MENU["name"] == UnitName("player") then
					IsAlreadyFriend = true
				end
			end
			if not IsAlreadyFriend then				
				CreateAddFriendButton()
			
			end
		end
	end		
end

function CreateAddFriendButton()

		local CancelButtonFrame = getglobal("DropDownList1Button"..DropDownList1.numButtons)
		CancelButtonFrame:Hide()
		DropDownList1.numButtons = DropDownList1.numButtons - 1
		UIDropDownMenu_AddButton(AddFriendButtonInfo)
		UIDropDownMenu_AddButton(CancelButtonInfo)
	
   end
end

--[[-----------------------------------------------------------------------------
Fatigue Warner
-------------------------------------------------------------------------------]]
if fatiguewarner then
function FatigueWarner_OnUpdate(self) 
	local timer, value, maxvalue, scale, paused, label = GetMirrorTimerInfo(1) 
	if timer == "EXHAUSTION" then 
-- You can change the sounds by deleting the -- in Front of those PlaySoundFile, so that only one will not have the -- in front of it.
              --PlaySoundFile("Sound\\Creature\\ShadeOfAran\\AranAggro01.wav" , "Master")					
              --PlaySoundFile("Sound\\Creature\\ElderIronbranch\\UR_Ironbranch_Aggro01.wav", "Master")	
                PlaySoundFile("Sound\\Creature\\XT002Deconstructor\\UR_XT002_Special01.wav", "Master")
              --PlaySoundFile("Sound\\Creature\\Hodir\\UR_Hodir_Aggro01.wav", "Master")
	end 
	self:SetScript("OnUpdate", nil) 
end 
 
function FatigueWarner_OnEvent(self) 
	self:SetScript("OnUpdate", FatigueWarner_OnUpdate) 
end 
	  
-- Sinnlos; strip bringt ja irgendwie nichts fiel mir dann auf :>
function FatigueWarner_Strip()
	local FatigueWarner_StripTable = {16, 17, 18, 5, 7, 1, 3, 10, 8, 6, 9}
	local start = 1
	local finish = table.getn(FatigueWarner_StripTable)

	for bag = 0, 4 do
		for slot=1, GetContainerNumSlots(bag) do
			if not GetContainerItemLink(bag, slot) then
				for i = start, finish do
					if GetInventoryItemLink("player", FatigueWarner_StripTable[i]) then
						PickupInventoryItem(FatigueWarner_StripTable[i])
						PickupContainerItem(bag, slot)
						start = i + 1
						break
					end
				end
			end
		end
	end
end

local FatigueWarnerFrame = CreateFrame("frame")
FatigueWarnerFrame:RegisterEvent("MIRROR_TIMER_START")
FatigueWarnerFrame:RegisterEvent("MIRROR_TIMER_STOP")
FatigueWarnerFrame:SetScript("OnEvent", FatigueWarner_OnEvent)
end

--[[-----------------------------------------------------------------------------
Interrupted msg
-------------------------------------------------------------------------------]]
if interruptedmsg then
eventHandlers['COMBAT_LOG_EVENT_UNFILTERED'] = function(...)
	local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16 = ...

	if arg2 ~= "SPELL_INTERRUPT" or arg5 ~= UnitName("player") then
		return
	end

        local channel = GetNumRaidMembers() > 0 and "RAID" or GetNumPartyMembers() > 0 and "PARTY"

	if channel then
		SendChatMessage(GetSpellLink(arg12).." 已打斷 "..GetSpellLink(arg15), channel)
	end
    end
end

--[[-----------------------------------------------------------------------------
ConfirmLeaveParty
-------------------------------------------------------------------------------]]
if leavepartymsg then
local CONFIRM_LEAVE_PARTY = "Do you really want to leave the group?"

if GetLocale() == "deDE" then
	CONFIRM_LEAVE_PARTY = "Willst du wirklich die Gruppe verlassen?" -- Shantalya @ WoWI
elseif GetLocale() == "esES" or GetLocale() == "esMX" then
	CONFIRM_LEAVE_PARTY = "¿Realmente quiere dejar el grupo?" -- Google Translate
elseif GetLocale() == "frFR" then
	CONFIRM_LEAVE_PARTY = "Veux-tu vraiment à quitter le groupe?" -- Google Translate
elseif GetLocale() == "ptBR" then
	CONFIRM_LEAVE_PARTY = "Tem certeza de que deseja sair o grupo?" -- Google Translate
elseif GetLocale() == "ruRU" then
	CONFIRM_LEAVE_PARTY = "Вы действительно хотите выйти из группы?" -- Google Translate
elseif GetLocale() == "koKR" then
	CONFIRM_LEAVE_PARTY = "당신이 정말로 그룹을 떠나시겠습니까?" -- Google Translate
elseif GetLocale() == "zhCN" then
	CONFIRM_LEAVE_PARTY = "難道妳真的想離開小隊嗎?" -- Google Translate
elseif GetLocale() == "zhTW" then
	CONFIRM_LEAVE_PARTY = "難道妳真的想離開組嗎?" -- Google Translate
end

------------------------------------------------------------------------

local ReallyLeaveParty = _G.LeaveParty

StaticPopupDialogs["CONFIRM_LEAVE_PARTY"] = {
	text = CONFIRM_LEAVE_PARTY,
	button1 = YES,
	button2 = NO,
	enterClicksFirstButton = 0, -- YES on enter
	hideOnEscape = 0, -- NO on escape
	timeout = 0,
	OnAccept = ReallyLeaveParty,
}

_G.LeaveParty = function()
	local _, instanceType = IsInInstance()
	if instanceType == "party" or instanceType == "raid" then
		if GetNumPartyMembers() > 0 or GetNumRaidMembers() > 0 then
			return StaticPopup_Show("CONFIRM_LEAVE_PARTY")
		end
	end
	ReallyLeaveParty()
end
end

--[[-----------------------------------------------------------------------------
Slash commands
-------------------------------------------------------------------------------]]
if slshCmnd_CommandLists then
        _G['SLASH_' .. addonName .. 'CommandLists1'] = strlower("/wc")
        SlashCmdList[addonName .. 'CommandLists'] = function()

	    print("|cff3399FF/lp|r - leave your Party/Raid.")
	    print("|cff3399FF/ui|r - Reloads your interface for you.")
	    print("|cff3399FF/xp|r - Output your experience status to chat.")
	    print("|cff3399FF/rc|r - Perform Ready check, Will post message if not Leader or Assist.")
	    print("|cff3399FF/dr|r - Disbands the raid group if you are Raid Leader or Assist.")
      end
end

if slshCmnd_LeaveParty then
        _G['SLASH_' .. addonName .. 'LeaveParty1'] = strlower("/lp")
        SlashCmdList[addonName .. 'LeaveParty'] = function() 

       local inInstance, _ = IsInInstance() 
       if GetNumPartyMembers() > 0 or GetNumRaidMembers() > 0 then 
                    LeaveParty() 
       elseif inInstance then 
                    LFGTeleport(true) 
       else print("|cff3399FF錯誤:|r 不在隊伍中.") 
      end 
   end
end

if slshCmnd_ReloadUI then
        _G['SLASH_' .. addonName .. 'ReloadUI1'] = strlower("/rl")
	SlashCmdList[addonName .. 'ReloadUI'] = ReloadUI
end

if slshCmnd_XP then
	local maxLevel = ({ 60, 70, 80 })[GetExpansionLevel() + 1] or 85

        _G['SLASH_' .. addonName .. 'XP1'] = strlower("/xp")
	SlashCmdList[addonName .. 'XP'] = function()
		if IsXPUserDisabled() then
			print("Experience gain is currently disabled for this character.")
		elseif UnitLevel('player') < maxLevel then
			local current, max, rested = UnitXP('player'), UnitXPMax('player'), GetXPExhaustion() or 0
			print(("經驗值: %d/%d (%2.2f%%)\n雙倍經驗: %d (%2.2f%%)\n下個等級: %d"):format(current, max, current / max * 100, rested, rested / max * 100,max - current))
		end
	end
end

if slshCmnd_Readycheck then
function Readycheck()
	if (UnitInRaid("player") ~= nil) and (GetNumRaidMembers() > 0) then
		if IsRaidLeader() or IsRaidOfficer() then
			DoReadyCheck()
		else
			print("|cff3399FFError:|r 妳不是團隊領袖或團隊助理, 不能執行就緒檢查.")
		end
	elseif (UnitInParty("player") ~= nil) and (GetNumPartyMembers() > 0) then
		if UnitIsPartyLeader("player") then
			DoReadyCheck()		
		else
			print("|cff3399FFError:|r 妳不是團隊領袖或團隊助理, 不能執行就緒檢查.")
		end
	else
		print("|cff3399FFError:|r Not in a group.") 
	end
end

        _G['SLASH_' .. addonName .. 'Readycheck1'] = strlower("/rc")
	SlashCmdList[addonName .. 'Readycheck'] = Readycheck
end

if slshCmnd_DisbandRaid then
function DisbandRaid()
        if (UnitInRaid("player") ~= nil) and (GetNumRaidMembers() > 0) then
               if IsRaidLeader() or IsRaidOfficer() then 
               SendChatMessage("< wIn1 > Disbanding Raid!", RAID, nil, nil) 
               local pName = UnitName("player") 
        for i = 1, GetNumRaidMembers() do 
        local name = GetRaidRosterInfo(i) 
        if name ~= pName then UninviteUnit(name) 
     end 
          end
               LeaveParty() 
        else print("|cff3399FFError:|r 妳不是團隊領袖或團隊助理, 不能執行就緒檢查.|r") 
      end 
	else
		print("|cff3399FFError:|r Not in a Raid.") 
	end
   end
        _G['SLASH_' .. addonName .. 'DisbandRaid1'] = strlower("/dr")
	SlashCmdList[addonName .. 'DisbandRaid'] = DisbandRaid
end

if slshCmnd_ConvertToParty then
        _G['SLASH_' .. addonName .. 'ConvertToParty1'] = strlower("/c2p")
	SlashCmdList[addonName .. 'ConvertToParty'] = function()
		local numRaid = GetNumRaidMembers()
		if numRaid == 0 then
			print("|cff3399ffError:|r 妳不在壹個團隊中.")
		elseif numRaid <= MEMBERS_PER_RAID_GROUP then
			ConvertToParty()
			print("|cff3399ffMessage:|r 妳的團隊現在是小隊.")
		else
			print("|cff3399ffError:|r 不能轉換團隊為小隊.")
		end
	end
end

if slshCmnd_ConvertToRaid then
        _G['SLASH_' .. addonName .. 'ConvertToRaid1'] = strlower("/c2r")
	SlashCmdList[addonName .. 'ConvertToRaid'] = function()
		if GetNumRaidMembers() > 0 then
			print("|cff3399ffError:|r 妳已經在團隊中.")
		elseif GetNumPartyMembers() > 0 then
			ConvertToRaid()
			print("|cff3399ffMessage:|r 妳的小隊現在是團隊.")
		else
			print("|cff3399ffError:|r 妳不在壹個小隊中.")
		end
	end
end

--[[-----------------------------------------------------------------------------
Initialize
-------------------------------------------------------------------------------]]
if next(eventHandlers) then
	local frame = CreateFrame('Frame')
	frame:Hide()

	for event, handler in pairs(eventHandlers) do
		frame[event] = handler
		frame:RegisterEvent(event)
		eventHandlers[event] = nil
	end

	frame:SetScript('OnEvent', function(self, event, ...)
		self[event](...)
	end)
end

print("|cff3399ffw|rIn1 已加載, 由老超@網易魔獸插件站漢化發布.")
